package eu.eudat.migration;

import eu.eudat.migration.services.DMPRoadmapService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.builder.SpringApplicationBuilder;
import org.springframework.boot.context.properties.ConfigurationPropertiesScan;
import org.springframework.context.ConfigurableApplicationContext;

@SpringBootApplication(
        scanBasePackages = "eu.eudat"
)
@ConfigurationPropertiesScan("eu.eudat.migration.properties")
public class DMPRoadmapMigration implements CommandLineRunner {

    private final DMPRoadmapService service;
    private static ConfigurableApplicationContext context;

    @Autowired
    public DMPRoadmapMigration(DMPRoadmapService service) {
        this.service = service;
    }

    public static void main(String[] args) {
       context = new SpringApplicationBuilder(DMPRoadmapMigration.class).run(args);
       context.close();
    }

    @Override
    public void run(String... args) throws Exception {
        this.service.migrateUsers();
        this.service.migrate();
    }
}
