package eu.eudat.migration.dao;

import eu.eudat.migration.entities.Template;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.data.domain.Sort;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;

import java.util.List;

@ConditionalOnProperty(prefix = "roadmap", name="database.url")
public interface TemplateRepository extends JpaRepository<Template, Long> {

    @Query(value = "SELECT DISTINCT (t.familyId) from Template t")
    List<Long> findAllGroups();

    List<Template> findAllByFamilyId(Long familyId, Sort sort);
}
